/* FunctionList.c	James M Synge	16-Apr-1987	*/

/* This file contains the function table whose address is
 * passed to MakeLibrary.  This table is used to create the
 * jump table which will immediately proceed the library
 * structure in memory.  Notice that the first three entries
 * are the assembly language interludes in the file
 * LibHead.ASM.
 */

/* Required routines:					*/

long _Library_Open();	/* Called by OpenLibrary().	*/
long _Library_Close();	/* Called by CloseLibrary().	*/
long _Library_Expunge();/* Called by memory allocator.	*/
long  Library_Reserved();	/* Must return 0L.	*/

/* Public, library specific routines:			*/

long _CreateTask();
long _DeleteTask();

long (* FunctionList[])() = {

	_Library_Open,
	_Library_Close,
	_Library_Expunge,
	 Library_Reserved,

	_CreateTask,
	_DeleteTask,

	-1L	/* Marks the end of the list. */
};
